package com.mycompany;

import org.apache.wicket.Component;
import org.apache.wicket.Page;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.form.AjaxSubmitLink;
import org.apache.wicket.atmosphere.EventBus;
import org.apache.wicket.atmosphere.Subscribe;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.model.Model;
import org.apache.wicket.serialize.java.JavaSerializer;

public class HomePage extends WebPage {

    private static final long serialVersionUID = 1L;

    private Component messageLabel;

    public HomePage() {
        super();
        add(messageLabel = new Label("message", Model.of("-")).setOutputMarkupId(true));
        messageLabel.setOutputMarkupId(true);
        Form form = new Form("form");
        add(form);
        form.add(new AjaxSubmitLink("send", form) {
            private static final long serialVersionUID = 1L;

            @Override
            protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
                EventBus.get().post("Hello");

                JavaSerializer serializer = new JavaSerializer("test");
                Page p = target.getPage();
                System.out.println("Page: " + serializer.serialize(p).length);
            }

            @Override
            protected void onError(AjaxRequestTarget target, Form<?> form) {
            }
        });
    }

    @Subscribe
    public void receiveMessage(AjaxRequestTarget target, String event) {
        messageLabel.setDefaultModelObject(event);
        target.add(messageLabel);
    }
}
